<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:24 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib("search");

	Extract (
		URLGetArgs ("null?q=data&base=alpha&page=int")
	);

	if (!$base)
		$base = "*";

	if ($page <= 0)
		$page = "1";

	$total = 0;

	$tpl = new ContentBlock();
	$tpl->insert("BLOCK_CONTENT", "search/index.tpl");

	$items_per_page = conf::getkey("search", "items_per_page", 10, "i");
	
	if ($q) {

		$keywords_array = explode(" ", $q);

		// keywords to use with MySQL LIKE
		$keywords = "%".str_replace(" ", " % ", $q)."%";

		// counters
		$results = 0;
		$search_begin = ($page-1)*$items_per_page;
		$search_end = $search_begin + $items_per_page;

		// continue to saving results
		$fetch_results = true;

		// limiting results
		$sql_limit = "";

		if ($base == "*") {
			$modules = search::getModules();
			// this is not a module
			unset($modules["*"]);
		} else
			$modules = array($base);
		
		foreach ($modules as $module) {

			// variable $p is our query result
			unset ($p);

			$data = array();

			include GEKKO_ROOT."modules/$module/mod_search.inc.php";

			if (isset($p))
				$total += $GLOBALS["db"]->num_rows($p);

			if ($fetch_results) {

				foreach ($data as $row) {

					$results++;

					if ($results <= $search_begin)
						continue;

					// this function is supposed to highlight the searched words
					search::hightlight($row["description"], $keywords_array);

					// 
					if (strlen($row["description"]) > 250)
						$row["description"] = mkintro($row["description"], 250);

					$tpl->set_arr($row, "RESULT");
					$tpl->saveBuff("RESULT");

					// search limit
					if ($results >= $search_end) {
						$fetch_results = false;
						break;
					}

				}	
			}
		}
	}

	$base = htmlspecialchars($base);
	$q = htmlspecialchars($q);

	$tpl->set_arr (
		Array (
			"BLOCK_TITLE"		=> _l("L_SEARCH"),
			"BLOCK_ICON"		=> mkIcon("search.png"),
			"BASE"				=> $base,
			"SEARCH_TERMS"		=> $q,
			"PAGER"				=> mkPager(round($total/$items_per_page), $page, urlevalprototype("index.php/module=search?q=$q&base=$base&page=%p"))
		)
	);

	$mcBuff = $tpl->make();
?>